/*
 * Created on 05.07.2004
 */
package audiotoscreen;

import javax.swing.*;
import javax.sound.sampled.*;
import java.awt.Graphics;
import java.io.*;

/**
 * @author jl
 */
public class AudioToScreen extends JFrame {

	public static void main(String[] args) {
		AudioToScreen myFrame = new AudioToScreen();
		myFrame.getContentPane().add(new OscPanel());
		myFrame.setSize(600, 500);
		myFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);		
		myFrame.show();
	}
}

class OscPanel extends JPanel
{
	private AudioInputStream inStream;
	
	OscPanel()
	{
		try
		{
			File inFile = new File("C:\\WINDOWS\\Media\\Windows XP-Startvorgang.wav");
			AudioFileFormat aff = AudioSystem.getAudioFileFormat(inFile);
			AudioFormat af = aff.getFormat();
			if(af.isBigEndian())
				throw new Exception("no litte endian");
			if(af.getChannels() != 2)
				throw new Exception("no stereo file");
			if(af.getSampleSizeInBits() != 16)
				throw new Exception("no 16 bit file");
			
			inStream = AudioSystem.getAudioInputStream(inFile);				
		}
		catch(Exception e)
		{
			throw new RuntimeException(e);
		}
	}	
	
	public void paint(Graphics g)
	{
		super.paint(g);
		
		try
		{
			byte[] buffer = new byte[2000];
			int numBytesRead = inStream.read(buffer);
			
			int wOld = 0;
			for(int i = 0; i < numBytesRead/4; i++)
			{
				int lo = buffer[4*i];
				int hi = buffer[4*i+1];
				short v = (short)((hi << 8) | (lo & 0xFF));
				int w = 300+v/100;
				if(i > 0)
					g.drawLine(i-1, wOld, i, w);
				wOld = w;				
			}
		}
		catch(Exception e)
		{
			throw new RuntimeException(e);
		}	
		
		repaint();		
	}
}